﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using DotNetCore.CAP;
using Hotline.Share.Dtos.Order;
using Hotline.Share.Mq;
using MapsterMapper;
using Microsoft.Extensions.Logging;
using XF.Domain.Dependency;
using XF.Domain.Repository;

namespace DataSharing.Application.Province
{
    public class ProvinceReceiver : ICapSubscribe, IScopeDependency
    {
        private readonly IRepository<DsOrder> _orderRepository;
        private readonly IMapper _mapper;
        private readonly ILogger<ProvinceReceiver> _logger;

        public ProvinceReceiver(
            IRepository<DsOrder> orderRepository,
            IMapper mapper,
            ILogger<ProvinceReceiver> logger)
        {
            _orderRepository = orderRepository;
            _mapper = mapper;
            _logger = logger;
        }

        [CapSubscribe(EventNames.HotlineOrderFlowStarted)]
        public async Task AddOrderAsync(OrderDto order, CancellationToken cancellationToken)
        {
            var dsOrder = _mapper.Map<DsOrder>(order);
            dsOrder.Data = System.Text.Json.JsonSerializer.Serialize(order);
            await _orderRepository.AddAsync(dsOrder, cancellationToken);
        }
        
    }
}
