﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using SqlSugar;
using XF.Domain.Repository;

namespace DataSharing
{
    /// <summary>
    /// 发送任务
    /// </summary>
    public class DsSendTask : CreationEntity
    {
        /// <summary>
        /// 任务优先级(0:最低级别)
        /// </summary>
        public int TaskPriority { get; set; }
        
        /// <summary>
        /// 初次推送时间
        /// </summary>
        public DateTime? FirstTime { get; set; }

        /// <summary>
        /// 最近一次推送时间
        /// </summary>
        public DateTime? LastTime { get; set; }

        /// <summary>
        /// 推送成功时间
        /// </summary>
        public DateTime? SuccessTime { get; set; }

        /// <summary>
        /// 推送次数
        /// </summary>
        public int SendTimes { get; set; }

        /// <summary>
        /// 推送成功
        /// </summary>
        public bool IsSuccess { get; set; }

        /// <summary>
        /// 任务类型
        /// addOrder, expiredTimeChanged...
        /// </summary>
        public string TaskType { get; set; }

        /// <summary>
        /// 请求方式
        /// </summary>
        public string HttpMethod { get; set; }

        /// <summary>
        /// 请求地址
        /// </summary>
        public string Path { get; set; }

        /// <summary>
        /// 请求参数
        /// </summary>
        [SugarColumn(Length = 5000)]
        public string Request { get; set; }
    }
}
